
65C816
======

### Syntax
**naken\_asm** uses syntax that is in keeping with modern programming styles, please refer to the main documentation for a full description. Some traditional syntax is also available:

| Traditional    | Modern                     | Description                  |
|:---------------|:---------------------------|:-----------------------------|
| lda #44        | lda #44                    | decimal representation       |
| lda #$44       | lda #0x44                  | hexadecimal representation   |
| lda #%10101010 | lda #10101010b             | binary representation\*      |
| lda #<$444444  | lda #444444 & 0xFF         | low byte                     |
| lda #>$444444  | lda #(444444 >> 8) & 0xFF  | middle byte                  |
| lda #^$444444  | lda #(444444 >> 16) & 0xFF | high byte                    |
| lda <$4444     | lda.b 0x4444               | force direct mode            |
| lda !$4444     | lda.w 0x4444               | force absolute mode          |
| lda >$4444     | lda.l 0x4444               | force absolute long mode     |

\**Traditional binary and octal formats are not currently supported.*

By default, the assembler will assume these addressing modes based on the value:

| Address Range     | Addressing Mode       |
|:------------------|:----------------------|
| 0x00-0xFF         | Direct Page           |
| 0x00-0xFFFF       | Absolute              |
| 0x00-0xFFFFFF     | Absolute Long         |

In immediate mode, **.b** forces a byte quantity, and **.w** forces a word. If the value is an address, then **.b** forces direct mode, **.w** forces absolute mode, and **.l** forces absolute long mode.

Though the 65816 has 24-bit addressing modes, the program counter is 16-bit only. Therefore the program must reside between 0x0000 and 0xFFFF, and the bank should be selected with the Program Bank Register. *Note: There is no "re-org" directive, so modules using different banks should be placed in separate files to avoid problems.*


