Literals
========

All numbers can be spaced out with underscores.  For example 100_100
will be interpreted as 100000 and 0x1234_3333 will be interpreted
as 0x1234333.

Hexadecimal
-----------

Hexadecimals values can be prefixed with 0x or postfixed with h.  For
example the following are valid and the same:

0x1234, 1234h, 0x12_34

Binary
------

Binary numbers can be prefixed with 0b or postfixed with b.  For
example the following are valid and the same:

0b1001, 1001b, 0xb10_01

Octal
-----

Octal numbers are postfixed with q.  For example the following is
a valid octal number:

17q

Special Characters
------------------

As with other assemblers, $ means "current address".  So a jmp $ will be
an infinite loop.

Floating Point
--------------

There is some 32 bit floating point support.  When using dc32, for
example, floating point data will be turned into binary.  For expressions,
Any time logical operations (and, or, xor) both values are turned into
binary and for shifting the "shift by" value turns into an integer.
So 5 >> 3.0 is the same as 5 >> 3.

  dc32 1.0, 1.0, 0.0, 0.0
  dc64 (1.0 << 32)

Will become:

0000: 00 00 80 3f 00 00 80 3f 00 00 00 00 00 00 00 00  ...?...?........
0010: 00 00 00 00 00 00 80 3f                          .......?

The floating point support is done through eval_expression_ex() in
the assembler, which is not used everywhere.  Drop me an email if
something doesn't make sense and I can straighten it out with either
an answer or a code change.

