;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Wixel / 8051 include
;; part of the naken_asm assembler
;;
;; Generated by: Michael Kohn (mike@mikekohn.net)
;;         Date: 2016-08-28
;;        Parts: Pololu Wixel
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.macro SET_REGISTER(register, value)
  mov DPTR, #register
  mov A, #value
  movx @DPTR, A
.endm

U0CSR equ 0x86
U0GCR equ 0xc5
U0DBUF equ 0xc1
U0BAUD equ 0xc2
PERCFG equ 0xf1
P0SEL equ 0xf3
P1SEL equ 0xf4
P2SEL equ 0xf5
P0DIR equ 0xfd
P1DIR equ 0xfe
P2DIR equ 0xff
P0INP equ 0x8f
P1INP equ 0xf6
P2INP equ 0xf7

T1CNTH equ 0xe3
T1CNTL equ 0xe2
T1CTL equ 0xe4
T1CCTL0 equ 0xe5
T1CC0H equ 0xdb
T1CC0L equ 0xda
T1CCTL1 equ 0xe6
T1CC1H equ 0xdd
T1CC1L equ 0xdc
T1CCTL2 equ 0xe7

IEN1 equ 0xb8

SLEEP equ 0xbe
CLKCON equ 0xc6

RFST equ 0xe1
RFD equ 0xd9
RFIM equ 0x91
RFIF equ 0xe9
RFTXRXIE equ 0
RFTXRXIF equ 1

PA_TABLE0 equ 0xdf2e
PKTCTRL0 equ 0xdf04
PKTCTRL1 equ 0xdf03
PKTLEN equ 0xdf02
PKTSTATUS equ 0xdf3c

MARCSTATE equ 0xdf3b
MCSM0 equ 0xdf14
MCSM1 equ 0xdf13
MCSM2 equ 0xdf12

TEST0 equ 0xdf25
TEST1 equ 0xdf24
TEST2 equ 0xdf23

SFSTXON equ 0x00
SCAL equ 0x01
SRX equ 0x02
STX equ 0x03
SIDLE equ 0x04

MDMCFG0 equ 0xdf10
MDMCFG1 equ 0xdf0f
MDMCFG2 equ 0xdf0e
MDMCFG3 equ 0xdf0d
MDMCFG4 equ 0xdf0c

FREQ0 equ 0xdf0b
FREQ1 equ 0xdf0a
FREQ2 equ 0xdf09
FREND0 equ 0xdf1b
FREND1 equ 0xdf1a
FOCCFG equ 0xdf15
FSCTRL0 equ 0xdf08
FSCTRL1 equ 0xdf07
FSCAL0 equ 0xdf1f
FSCAL1 equ 0xdf1e
FSCAL2 equ 0xdf1d
FSCAL3 equ 0xdf1c

BSCFG equ 0xdf16
AGCCTRL0 equ 0xdf19
AGCCTRL1 equ 0xdf18
AGCCTRL2 equ 0xdf17

ADDR equ 0xdf05
CHANNR equ 0xdf06
LQI equ 0xdf38

IOCFG0 equ 0xdf31
IOCFG1 equ 0xdf30
IOCFG2 equ 0xdf2f

DMA_CHANNEL_RADIO equ 1
DMAARM equ 0xd6
DMAREQ equ 0xd7
DMA0CFGL equ 0xd4
DMA0CFGH equ 0xd5
DMA1CFGL equ 0xd2
DMA1CFGH equ 0xd3
DMAIRQ equ 0xd1

ENDIAN equ 0x95

