;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Amiga include file
;; Part of the naken_asm assembler
;;
;; Generated by: Michael Kohn (mike@mikekohn.net)
;;         From: http://amiga-dev.wikidot.com/information:hardware
;;         Date: 2018-Dec-28
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Custom chips

BLTDDAT  equ 0x000 ; Blitter dest. early read (dummy address)
DMACONR  equ 0x002 ; DMA control (and blitter status) read
VPOSR    equ 0x004 ; Read vertical most sig. bits (and frame flop)
VHPOSR   equ 0x006 ; Read vert and horiz position of beam
DSKDATR  equ 0x008 ; Disk data early read (dummy address)
JOY0DAT  equ 0x00a ; Joystick-mouse 0 data (vert, horiz)
JOY1DAT  equ 0x00c ; Joystick-mouse 1 data (vert, horiz)
CLXDAT   equ 0x00e ; Collision data reg. (read and clear)
ADKCONR  equ 0x010 ; Audio,disk control register read
POT0DAT  equ 0x012 ; Pot counter data left pair (vert, horiz)
POT1DAT  equ 0x014 ; Pot counter data right pair (vert, horiz)
POTINP   equ 0x016 ; Pot pin data read
SERDATR  equ 0x018 ; Serial port data and status read
DSKBYTR  equ 0x01a ; Disk data byte and status read
INTENAR  equ 0x01c ; Interrupt enable bits read
INTREQR  equ 0x01e ; Interrupt request bits read
DSKPTH   equ 0x020 ; Disk pointer (high 5 bits, was 3 bits)
DSKPTL   equ 0x022 ; Disk pointer (low 15 bits)
DSKLEN   equ 0x024 ; Disk length
DSKDAT   equ 0x026 ; Disk DMA data write
REFPTR   equ 0x028 ; Refresh pointer
VPOSW    equ 0x02a ; Write vert most sig. bits (and frame flop)
VHPOSW   equ 0x02c ; Write vert and horiz pos of beam
COPCON   equ 0x02e ; Coprocessor control
SERDAT   equ 0x030 ; Serial port data and stop bits write
SERPER   equ 0x032 ; Serial port period and control
POTGO    equ 0x034 ; Pot count start,pot pin drive enable data
JOYTEST  equ 0x036 ; Write to all 4 joystick-mouse counters at once
STREQU   equ 0x038 ; Strobe for horiz sync with VB and EQU
STRVBL   equ 0x03a ; Strobe for horiz sync with VB (vert blank)
STRHOR   equ 0x03c ; Strobe for horiz sync
STRLONG  equ 0x03e ; Strobe for identification of long horiz line
BLTCON0  equ 0x040 ; Blitter control register 0
BLTCON1  equ 0x042 ; Blitter control register 1
BLTAFWM  equ 0x044 ; Blitter first word mask for source A
BLTALWM  equ 0x046 ; Blitter last word mask for source A
BLTCPTH  equ 0x048 ; Blitter pointer to source C (high 5 bits, was 3 bits)
BLTCPTL  equ 0x04a ; Blitter pointer to source C (low 15 bits)
BLTBPTH  equ 0x04c ; Blitter pointer to source B (high 5 bits, was 3 bits)
BLTBPTL  equ 0x04e ; Blitter pointer to source B (low 15 bits)
BLTAPTH  equ 0x050 ; Blitter pointer to source A (high 5 bits, was 3 bits)
BLTAPTL  equ 0x052 ; Blitter pointer to source A (low 15 bits)
BLTDPTH  equ 0x054 ; Blitter pointer to dest D (high 5 bits, was 3 bits)
BLTDPTL  equ 0x056 ; Blitter pointer to dest D (low 15 bits)
BLTSIZE  equ 0x058 ; Blitter start and size (win/width,height)
BLTCON0L equ 0x05a ; Blitter control 0, lower 8 bits (minterms) (ECS)
BLTSIZV  equ 0x05c ; Blitter V size (for 15 bit vertical size) (ECS)
BLTSIZH  equ 0x05e ; Blitter H size and start (for 11 bit H size) (ECS)
BLTCMOD  equ 0x060 ; Blitter modulo for source C
BLTBMOD  equ 0x062 ; Blitter modulo for source B
BLTAMOD  equ 0x064 ; Blitter modulo for source A
BLTDMOD  equ 0x066 ; Blitter modulo for dest D
BLTCDAT  equ 0x070 ; Blitter source C data register
BLTBDAT  equ 0x072 ; Blitter source B data register
BLTADAT  equ 0x074 ; Blitter source A data register
SPRHDAT  equ 0x078 ; Ext. logic UHRES sprite pointer and data identifier (ECS)
BPLHDAT  equ 0x07a ; Ext. logic UHRES bit plane identifier (ECS)
DENISEID equ 0x07c ; Chip revision level for Denise/Lisa (video out chip) (ECS)
DSKSYNC  equ 0x07e ; Disk sync pattern reg for disk read
COP1LCH  equ 0x080 ; Coprocessor 1st location (high 5 bits,was 3 bits)
COP1LCL  equ 0x082 ; Coprocessor 1st location (low 15 bits)
COP2LCH  equ 0x084 ; Coprocessor 2nd location(high 5 bits,was 3 bits)
COP2LCL  equ 0x086 ; Coprocessor 2nd location (low 15 bits)
COPJMP1  equ 0x088 ; Coprocessor restart at 1st location
COPJMP2  equ 0x08a ; Coprocessor restart at 2nd location
COPINS   equ 0x08c ; Coprocessor inst fetch identify
DIWSTRT  equ 0x08e ; Display window start (upper left vert,horiz pos)
DIWSTOP  equ 0x090 ; Display window stop (lower right vert,horiz pos)
DDFSTRT  equ 0x092 ; Display bit plane data fetch start,horiz pos
DDFSTOP  equ 0x094 ; Display bit plane data fetch stop,horiz pos
DMACON   equ 0x096 ; DMA control write (clear or set)
CLXCON   equ 0x098 ; Collision control
INTENA   equ 0x09a ; Interrupt enable bits (clear or set bits)
INTREQ   equ 0x09c ; Interrupt request bits (clear or set bits)
ADKCON   equ 0x09e ; Audio,disk,UART control
AUD0LCH  equ 0x0a0 ; Audio channel 0 location (high 5 bits was 3 bits)
AUD0LCL  equ 0x0a2 ; Audio channel 0 location (low 15 bits)
AUD0LEN  equ 0x0a4 ; Audio channel 0 length
AUD0PER  equ 0x0a6 ; Audio channel 0 period
AUD0VOL  equ 0x0a8 ; Audio channel 0 volume
AUD0DAT  equ 0x0aa ; Audio channel 0 data
AUD1LCH  equ 0x0b0 ; Audio channel 1 location (high 5 bits was 3 bits)
AUD1LCL  equ 0x0b2 ; Audio channel 1 location (low 15 bits)
AUD1LEN  equ 0x0b4 ; Audio channel 1 length
AUD1PER  equ 0x0b6 ; Audio channel 1 period
AUD1VOL  equ 0x0b8 ; Audio channel 1 volume
AUD1DAT  equ 0x0ba ; Audio channel 1 data
AUD2LCH  equ 0x0c0 ; Audio channel 2 location (high 5 bits was 3 bits)
AUD2LCL  equ 0x0c2 ; Audio channel 2 location (low 15 bits)
AUD2LEN  equ 0x0c4 ; Audio channel 2 length
AUD2PER  equ 0x0c6 ; Audio channel 2 period
AUD2VOL  equ 0x0c8 ; Audio channel 2 volume
AUD2DAT  equ 0x0ca ; Audio channel 2 data
AUD3LCH  equ 0x0d0 ; Audio channel 3 location (high 5 bits was 3 bits)
AUD3LCL  equ 0x0d2 ; Audio channel 3 location (low 15 bits)
AUD3LEN  equ 0x0d4 ; Audio channel 3 length
AUD3PER  equ 0x0d6 ; Audio channel 3 period
AUD3VOL  equ 0x0d8 ; Audio channel 3 volume
AUD3DAT  equ 0x0da ; Audio channel 3 data
BPL1PTH  equ 0x0e0 ; Bitplane pointer 1 (high 5 bits was 3 bits)
BPL1PTL  equ 0x0e2 ; Bitplane pointer 1 (low 15 bits)
BPL2PTH  equ 0x0e4 ; Bitplane pointer 2 (high 5 bits was 3 bits)
BPL2PTL  equ 0x0e6 ; Bitplane pointer 2 (low 15 bits)
BPL3PTH  equ 0x0e8 ; Bitplane pointer 3 (high 5 bits was 3 bits)
BPL3PTL  equ 0x0ea ; Bitplane pointer 3 (low 15 bits)
BPL4PTH  equ 0x0ec ; Bitplane pointer 4 (high 5 bits was 3 bits)
BPL4PTL  equ 0x0ee ; Bitplane pointer 4 (low 15 bits)
BPL5PTH  equ 0x0f0 ; Bitplane pointer 5 (high 5 bits was 3 bits)
BPL5PTL  equ 0x0f2 ; Bitplane pointer 5 (low 15 bits)
BPL6PTH  equ 0x0f4 ; Bitplane pointer 6 (high 5 bits was 3 bits)
BPL6PTL  equ 0x0f6 ; Bitplane pointer 6 (low 15 bits)
BPL7PTH  equ 0x0f8 ; Bitplane pointer 7 (high 5 bits was 3 bits) (AGA)
BPL7PTL  equ 0x0fa ; Bitplane pointer 7 (low 15 bits) (AGA)
BPL8PTH  equ 0x0fc ; Bitplane pointer 8 (high 5 bits was 3 bits) (AGA)
BPL8PTL  equ 0x0fe ; Bitplane pointer 8 (low 15 bits) (AGA)
BPLCON0  equ 0x100 ; Bitplane control (miscellaneous control bits)
BPLCON1  equ 0x102 ; Bitplane control (scroll value)
BPLCON2  equ 0x104 ; Bitplane control (video priority control)
BPLCON3  equ 0x106 ; Bitplane control (enhanced features)
BPL1MOD  equ 0x108 ; Bitplane modulo (odd planes)
BPL2MOD  equ 0x10a ; Bitplane modulo (even planes)
BPLCON4  equ 0x10c ; Bitplane control (bitplane and sprite-masks) (AGA)
CLXCON2  equ 0x10e ; Extended collision control (AGA)
BPL1DAT  equ 0x110 ; Bitplane 1 data (parallel to serial convert)
BPL2DAT  equ 0x112 ; Bitplane 2 data (parallel to serial convert)
BPL3DAT  equ 0x114 ; Bitplane 3 data (parallel to serial convert)
BPL4DAT  equ 0x116 ; Bitplane 4 data (parallel to serial convert)
BPL5DAT  equ 0x118 ; Bitplane 5 data (parallel to serial convert)
BPL6DAT  equ 0x11a ; Bitplane 6 data (parallel to serial convert)
BPL7DAT  equ 0x11c ; Bitplane 7 data (parallel to serial convert) (AGA)
BPL8DAT  equ 0x11e ; Bitplane 8 data (parallel to serial convert) (AGA)
SPR0PTH  equ 0x120 ; Sprite 0 pointer (high 5 bits was 3 bits)
SPR0PTL  equ 0x122 ; Sprite 0 pointer (low 15 bits)
SPR1PTH  equ 0x124 ; Sprite 1 pointer (high 5 bits was 3 bits)
SPR1PTL  equ 0x126 ; Sprite 1 pointer (low 15 bits)
SPR2PTH  equ 0x128 ; Sprite 2 pointer (high 5 bits was 3 bits)
SPR2PTL  equ 0x12a ; Sprite 2 pointer (low 15 bits)
SPR3PTH  equ 0x12c ; Sprite 3 pointer (high 5 bits was 3 bits)
SPR3PTL  equ 0x12e ; Sprite 3 pointer (low 15 bits)
SPR4PTH  equ 0x130 ; Sprite 4 pointer (high 5 bits was 3 bits)
SPR4PTL  equ 0x132 ; Sprite 4 pointer (low 15 bits)
SPR5PTH  equ 0x134 ; Sprite 5 pointer (high 5 bits was 3 bits)
SPR5PTL  equ 0x136 ; Sprite 5 pointer (low 15 bits)
SPR6PTH  equ 0x138 ; Sprite 6 pointer (high 5 bits was 3 bits)
SPR6PTL  equ 0x13a ; Sprite 6 pointer (low 15 bits)
SPR7PTH  equ 0x13c ; Sprite 7 pointer (high 5 bits was 3 bits)
SPR7PTL  equ 0x13e ; Sprite 7 pointer (low 15 bits)
SPR0POS  equ 0x140 ; Sprite 0 vert,horiz start pos data
SPR0CTL  equ 0x142 ; Sprite 0 position and control data
SPR0DATA equ 0x144 ; Sprite 0 image data register A
SPR0DATB equ 0x146 ; Sprite 0 image data register B
SPR1POS  equ 0x148 ; Sprite 1 vert,horiz start pos data
SPR1CTL  equ 0x14a ; Sprite 1 position and control data
SPR1DATA equ 0x14c ; Sprite 1 image data register A
SPR1DATB equ 0x14e ; Sprite 1 image data register B
SPR2POS  equ 0x150 ; Sprite 2 vert,horiz start pos data
SPR2CTL  equ 0x152 ; Sprite 2 position and control data
SPR2DATA equ 0x154 ; Sprite 2 image data register A
SPR2DATB equ 0x156 ; Sprite 2 image data register B
SPR3POS  equ 0x158 ; Sprite 3 vert,horiz start pos data
SPR3CTL  equ 0x15a ; Sprite 3 position and control data
SPR3DATA equ 0x15c ; Sprite 3 image data register A
SPR3DATB equ 0x15e ; Sprite 3 image data register B
SPR4POS  equ 0x160 ; Sprite 4 vert,horiz start pos data
SPR4CTL  equ 0x162 ; Sprite 4 position and control data
SPR4DATA equ 0x164 ; Sprite 4 image data register A
SPR4DATB equ 0x166 ; Sprite 4 image data register B
SPR5POS  equ 0x168 ; Sprite 5 vert,horiz start pos data
SPR5CTL  equ 0x16a ; Sprite 5 position and control data
SPR5DATA equ 0x16c ; Sprite 5 image data register A
SPR5DATB equ 0x16e ; Sprite 5 image data register B
SPR6POS  equ 0x170 ; Sprite 6 vert,horiz start pos data
SPR6CTL  equ 0x172 ; Sprite 6 position and control data
SPR6DATA equ 0x174 ; Sprite 6 image data register A
SPR6DATB equ 0x176 ; Sprite 6 image data register B
SPR7POS  equ 0x178 ; Sprite 7 vert,horiz start pos data
SPR7CTL  equ 0x17a ; Sprite 7 position and control data
SPR7DATA equ 0x17c ; Sprite 7 image data register A
SPR7DATB equ 0x17e ; Sprite 7 image data register B
COLOR00  equ 0x180 ; Color table 0
COLOR01  equ 0x182 ; Color table 1
COLOR02  equ 0x184 ; Color table 2
COLOR03  equ 0x186 ; Color table 3
COLOR04  equ 0x188 ; Color table 4
COLOR05  equ 0x18a ; Color table 5
COLOR06  equ 0x18c ; Color table 6
COLOR07  equ 0x18e ; Color table 7
COLOR08  equ 0x190 ; Color table 8
COLOR09  equ 0x192 ; Color table 9
COLOR10  equ 0x194 ; Color table 10
COLOR11  equ 0x196 ; Color table 11
COLOR12  equ 0x198 ; Color table 12
COLOR13  equ 0x19a ; Color table 13
COLOR14  equ 0x19c ; Color table 14
COLOR15  equ 0x19e ; Color table 15
COLOR16  equ 0x1a0 ; Color table 16
COLOR17  equ 0x1a2 ; Color table 17
COLOR18  equ 0x1a4 ; Color table 18
COLOR19  equ 0x1a6 ; Color table 19
COLOR20  equ 0x1a8 ; Color table 20
COLOR21  equ 0x1aa ; Color table 21
COLOR22  equ 0x1ac ; Color table 22
COLOR23  equ 0x1ae ; Color table 23
COLOR24  equ 0x1b0 ; Color table 24
COLOR25  equ 0x1b2 ; Color table 25
COLOR26  equ 0x1b4 ; Color table 26
COLOR27  equ 0x1b6 ; Color table 27
COLOR28  equ 0x1b8 ; Color table 28
COLOR29  equ 0x1ba ; Color table 29
COLOR30  equ 0x1bc ; Color table 30
COLOR31  equ 0x1be ; Color table 31
HTOTAL   equ 0x1c0 ; Highest number count, horiz line (VARBEAMEN=1) (ECS)
HSSTOP   equ 0x1c2 ; Horizontal line position for HSYNC stop (ECS)
HBSTRT   equ 0x1c4 ; Horizontal line position for HBLANK start (ECS)
HBSTOP   equ 0x1c6 ; Horizontal line position for HBLANK stop (ECS)
VTOTAL   equ 0x1c8 ; Highest numbered vertical line (VARBEAMEN=1) (ECS)
VSSTOP   equ 0x1ca ; Vertical line position for VSYNC stop (ECS)
VBSTRT   equ 0x1cc ; Vertical line for VBLANK start (ECS)
VBSTOP   equ 0x1ce ; Vertical line for VBLANK stop (ECS)
SPRHSTRT equ 0x1d0 ; UHRES sprite vertical start (ECS)
SPRHSTOP equ 0x1d2 ; UHRES sprite vertical stop (ECS)
BPLHSTRT equ 0x1d4 ; UHRES bit plane vertical start (ECS)
BPLHSTOP equ 0x1d6 ; UHRES bit plane vertical stop (ECS)
HHPOSW   equ 0x1d8 ; DUAL mode hires H beam counter write (ECS)
HHPOSR   equ 0x1da ; DUAL mode hires H beam counter read (ECS)
BEAMCON0 equ 0x1dc ; Beam counter control register (SHRES,UHRES,PAL)
HSSTRT   equ 0x1de ; Horizontal sync start (VARHSY) (ECS)
VSSTRT   equ 0x1e0 ; Vertical sync start (VARVSY) (ECS)
HCENTER  equ 0x1e2 ; Horizontal position for Vsync on interlace (ECS)
DIWHIGH  equ 0x1e4 ; Display window - upper bits for start/stop (ECS)
BPLHMOD  equ 0x1e6 ; UHRES bit plane modulo (ECS)
SPRHPTH  equ 0x1e8 ; UHRES sprite pointer (high 5 bits) (ECS)
SPRHPTL  equ 0x1ea ; UHRES sprite pointer (low 15 bits) (ECS)
BPLHPTH  equ 0x1ec ; VRam (UHRES) bitplane pointer (hi 5 bits) (ECS)
BPLHPTL  equ 0x1ee ; VRam (UHRES) bitplane pointer (lo 15 bits) (ECS)
FMODE    equ 0x1fc ; Fetch mode register (AGA)

;; CIAA / CIAB
CIAA_PRA    equ 0x001 ; /FIR1 /FIR0 /RDY /TK0 /WPRO /CHNG /LED OVL
CIAA_PRB    equ 0x101 ; Parallel port
CIAA_DDRA   equ 0x201 ; Direction for port A (BFE001); 1=output (set to 0x03)
CIAA_DDRB   equ 0x301 ; Direction for port B (BFE101); 1=output (can be in or out)
CIAA_TALO   equ 0x401 ; CIAA timer A low byte (.715909 Mhz NTSC; .709379 Mhz PAL)
CIAA_TAHI   equ 0x501 ; CIAA timer A high byte
CIAA_TBLO   equ 0x601 ; CIAA timer B low byte (.715909 Mhz NTSC; .709379 Mhz PAL)
CIAA_TBHI   equ 0x701 ; CIAA timer B high byte
CIAA_TODLO  equ 0x801 ; 50/60 Hz event counter bits 7-0 (VSync or line tick)
CIAA_TODMID equ 0x901 ; 50/60 Hz event counter bits 15-8
CIAA_TODHI  equ 0xa01 ; 50/60 Hz event counter bits 23-16
CIAA_SDR    equ 0xc01 ; CIAA serial data register (connected to keyboard)
CIAA_ICR    equ 0xd01 ; CIAA interrupt control register
CIAA_CRA    equ 0xe01 ; CIAA control register A
CIAA_CRB    equ 0xf01 ; CIAA control register B
CIAB_PRA    equ 0x000 ; /DTR /RTS /CD /CTS /DSR SEL POUT BUSY
CIAB_PRB    equ 0x100 ; /MTR /SEL3 /SEL2 /SEL1 /SEL0 /SIDE DIR /STEP
CIAB_DDRA   equ 0x200 ; Direction for Port A (BFD000); 1 = output (set to 0xFF)
CIAB_DDRB   equ 0x300 ; Direction for Port B (BFD100); 1 = output (set to 0xFF)
CIAB_TALO   equ 0x400 ; CIAB timer A low byte (.715909 Mhz NTSC; .709379 Mhz PAL)
CIAB_TAHI   equ 0x500 ; CIAB timer A high byte
CIAB_TBLO   equ 0x600 ; CIAB timer B low byte (.715909 Mhz NTSC; .709379 Mhz PAL)
CIAB_TBHI   equ 0x700 ; CIAB timer B high byte
CIAB_TODLO  equ 0x800 ; Horizontal sync event counter bits 7-0
CIAB_TODMID equ 0x900 ; Horizontal sync event counter bits 15-8
CIAB_TODHI  equ 0xa00 ; Horizontal sync event counter bits 23-16
CIAB_SDR    equ 0xc00 ; CIAB serial data register (unused)
CIAB_ICR    equ 0xd00 ; CIAB interrupt control register
CIAB_CRA    equ 0xe00 ; CIAB Control register A
CIAB_CRB    equ 0xf00 ; CIAB Control register B

