;; enc28j60 - ethernet chip include file
;;
;; Date: February 20, 2012
;; Author: Michael Kohn
;; Email: mike@mikekohn.net
;; Web: http://www.mikekohn.net/
;;
;; Part of the naken_asm project

;; All Banks
EIE equ 0x1b
EIR equ 0x1c
ESTAT equ 0x1d
ECON2 equ 0x1e
ECON1 equ 0x1f

;; EIE
INTIE equ 0x80
PKTIE equ 0x40
DMAIE equ 0x20
LINKIE equ 0x10
TXIE equ 0x08
WOLIE equ 0x04
TXERIE equ 0x02
RXERIE equ 0x01

;; EIR
PKTIF equ 0x40
DMAIF equ 0x20
LINKIF equ 0x10
TXIF equ 0x08
WOLIF equ 0x04
TXERIF equ 0x02
RXERIF equ 0x01

;; ESTAT
INT equ 0x80
LATECOL equ 0x10
RXBUSY equ 0x04
TXABRT equ 0x02
CLKRDY equ 0x01

;; ECON2
AUTOINC equ 0x80
PKTDEC equ 0x40
PWRSV equ 0x20
VRPS equ 0x08

;; ECON1
TXRST equ 0x80
RXRST equ 0x40
DMAST equ 0x20
CSUMEN equ 0x10
TXRTS equ 0x08
RXEN equ 0x04
BSEL1 equ 0x02
BSEL0 equ 0x01

BANK0 equ 0x00
BANK1 equ 0x01
BANK2 equ 0x02
BANK3 equ 0x03

;; Bank 0
ERDPTL equ 0x00
ERDPTH equ 0x01
EWRPTL equ 0x02
EWRPTH equ 0x03
ETXSTL equ 0x04
ETXSTH equ 0x05
ETXNDL equ 0x06
ETXNDH equ 0x07
ERXSTL equ 0x08
ERXSTH equ 0x09
ERXNDL equ 0x0a
ERXNDH equ 0x0b
ERXRDPTL equ 0x0c
ERXRDPTH equ 0x0d
ERXWRPTL equ 0x0e
ERXWRPTH equ 0x0f
EDMASTL equ 0x10
EDMASTH equ 0x11
EDMANDL equ 0x12
EDMANDH equ 0x13
DMADSTL equ 0x14
DMADSTH equ 0x15
EDMACSL equ 0x16
EDMACSH equ 0x17

;; Bank 1
EHT0 equ 0x00
EHT1 equ 0x01
EHT2 equ 0x02
EHT3 equ 0x03
EHT4 equ 0x04
EHT5 equ 0x05
EHT6 equ 0x06
EHT7 equ 0x07
EPMM0 equ 0x08
EPMM1 equ 0x09
EPMM2 equ 0x0a
EPMM3 equ 0x0b
EPMM4 equ 0x0c
EPMM5 equ 0x0d
EPMM6 equ 0x0e
EPMM7 equ 0x0f
EPMCSL equ 0x10
EPMCSH equ 0x11
EPMOL equ 0x14
EPMOH equ 0x15
EWOLIE equ 0x16
EWOLIR equ 0x17
ERXFCON equ 0x18
EPKTCNT equ 0x19

;; EWOLIE
UCWOLIE equ 0x80
AWOLIE equ 0x40
PMWOLIE equ 0x10
MPWOLIE equ 0x08
HTWOLIE equ 0x04
MCWOLIE equ 0x02
BCWOLIE equ 0x01

;; EWOLIR
UCWOLIF equ 0x80
AWOLIF equ 0x40
PMWOLIF equ 0x10
MPWOLIF equ 0x08
HTWOLIF equ 0x04
MCWOLIF equ 0x02
BCWOLIF equ 0x01

;; ERXFCON
UCEN equ 0x80
ANDOR equ 0x40
CRCEN equ 0x20
PMEN equ 0x10
MPEN equ 0x08
HTEN equ 0x04
MCEN equ 0x02
BCEN equ 0x01


;; Bank 2
MACON1 equ 0x00
MACON2 equ 0x01
MACON3 equ 0x02
MACON4 equ 0x03
MABBIPG equ 0x04
MAIPGL equ 0x06
MAIPGH equ 0x07
MACLCON1 equ 0x08
MACLCON2 equ 0x09
MAMXFLL equ 0x0a
MAMXFLH equ 0x0b
MAPHSUP equ 0x0d
MICON equ 0x11
MICMD equ 0x12
MIREGADR equ 0x14
MIWRL equ 0x16
MIWRH equ 0x17
MIRDL equ 0x18
MIRDH equ 0x19

;; MACON1
LOOPBK equ 0x10
TXPAUS equ 0x08
RXPAUS equ 0x04
PASSALL equ 0x02
MARXEN equ 0x01

;; MACON2
MARST equ 0x80
RNDRST equ 0x40
MARXRST equ 0x08
RFUNRST equ 0x04
MATXRST equ 0x02
TFUNRST equ 0x01

;; MACON3
PADCFG2 equ 0x80
PADCFG1 equ 0x40
PADCFG0 equ 0x20
TXCRCEN equ 0x10
PHDRLEN equ 0x08
HFRMEN equ 0x04
FRMLNEN equ 0x02
FULDPX equ 0x01

;; MACON4
DEFER equ 0x40
BPEN equ 0x20
NOBKOFF equ 0x10
LONGPRE equ 0x02
PUREPRE equ 0x01

;; MAPHSUP
RSTINTFC equ 0x80
RSTRMII equ 0x08

;; MICON
RSTMII equ 0x80

;; MICMD
MIISCAN equ 0x02
MIIRD equ 0x01

;; Bank 3
MAADR1 equ 0x00
MAADR0 equ 0x01
MAADR3 equ 0x02
MAADR2 equ 0x03
MAADR5 equ 0x04
MAADR4 equ 0x05
EBSTSD equ 0x06
EBSTCON equ 0x07
EBSTCSL equ 0x08
EBSTCSH equ 0x09
MISTAT equ 0x0a
EREVID equ 0x12
ECOCON equ 0x15
EFLOCON equ 0x17
EPAUSL equ 0x18
EPAUSH equ 0x19

;; EBSTCON
PSV2 equ 0x80
PSV1 equ 0x40
PSV0 equ 0x20
PSEL equ 0x10
TMSEL1 equ 0x08
TMSEL0 equ 0x04
TME equ 0x02
BISTST equ 0x01

;; MISTAT
NVALID equ 0x04
SCAN equ 0x02
MBUSY equ 0x01

;; ECOCON
COCON2 equ 0x04
COCON1 equ 0x02
COCON0 equ 0x01

;; EFLOCON
FULDPXS equ 0x04
FCEN1 equ 0x02
FCEN0 equ 0x01

;; PHY
PHCON1 equ 0x00
PHSTAT1 equ 0x01
PHID1 equ 0x02
PHID2 equ 0x03
PHCON2 equ 0x10
PHSTAT2 equ 0x11
PHIE equ 0x12
PHIR equ 0x13
PHLCON equ 0x14

;; PHCON1
PRST equ 0x8000
PLOOPBK equ 0x4000
PPWRSV equ 0x0800
PDPXMD equ 0x0100

;; PHSTAT1
PFDPX equ 0x1000
PIDPX equ 0x0800
LLSTAT equ 0x0040
JBSTAT equ 0x0020

;; PHCON2
FRCLNK equ 0x4000
TXDIS equ 0x2000
JABBER equ 0x0400
DLDIS equ 0x0100

;; PHSTAT1
TXSTAT equ 0x2000
RXSTAT equ 0x1000
COLSTAT equ 0x0800
LSTAT equ 0x0400
DPXSTAT equ 0x0200
PLRITY equ 0x0010

;; PHIE
PLNKIE equ 0x0010
PGEIE equ 0x0002

;; PHIR
PLNKIF equ 0x0010
PGIF equ 0x0004

;; PLHCON
STRCH equ 0x0002

