;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Nintendo 64 RSP include file
;; Part of the naken_asm assembler
;;
;; Generated by: Michael Kohn (mike@mikekohn.net)
;;         From: RSP Programmer's Guide
;;         Date: 2020-Nov-08
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Coprocesser registers $c0 to $c15:

RSP_DMA_CACHE            equ 0x0
RSP_DMA_DRAM             equ 0x1
RSP_DMA_DMA_READ_LENGTH  equ 0x2
RSP_DMA_DMA_WRITE_LENGTH equ 0x3
RSP_SP_STATUS            equ 0x4
RSP_DMA_DMA_FULL         equ 0x5
RSP_DMA_DMA_BUSY         equ 0x6
RSP_SP_RESERVED          equ 0x7
RSP_CMD_START            equ 0x8
RSP_CMD_END              equ 0x9
RSP_CMD_CURRENT          equ 0xa
RSP_CMD_STATUS           equ 0xb
RSP_CMD_CLOCK            equ 0xc
RSP_CMD_BUSY             equ 0xd
RSP_CMD_PIPE_BUSY        equ 0xe
RSP_CMD_TMEM_BUSY        equ 0xf

;; RSP CPU view:

RSP_CPU_DMA_CACHE            equ 0x4040000
RSP_CPU_DMA_DRAM             equ 0x4040004
RSP_CPU_DMA_DMA_READ_LENGTH  equ 0x4040008
RSP_CPU_DMA_DMA_WRITE_LENGTH equ 0x404000c
RSP_CPU_SP_STATUS            equ 0x4040010
RSP_CPU_DMA_DMA_FULL         equ 0x4040014
RSP_CPU_DMA_DMA_BUSY         equ 0x4040018
RSP_CPU_SP_RESERVED          equ 0x404001c
RSP_CPU_CMD_START            equ 0x4100000
RSP_CPU_CMD_END              equ 0x4100004
RSP_CPU_CMD_CURRENT          equ 0x4100008
RSP_CPU_CMD_STATUS           equ 0x410000c
RSP_CPU_CMD_CLOCK            equ 0x4100010
RSP_CPU_CMD_BUSY             equ 0x4100014
RSP_CPU_CMD_PIPE_BUSY        equ 0x4100018
RSP_CPU_CMD_TMEM_BUSY        equ 0x410001c

;; Other RSP addresses:

RSP_DMEM equ 0x04000000
RSP_IMEM equ 0x04001000
RSP_PC   equ 0x04080000

